#include <stdio.h>

#define BS 8
#define CR 0xD
#define FULLPATH 3
#define SHORTPATH FULLPATH+25
#define SHORTLEN SHORTPATH+13
#define FCBPATH SHORTLEN+2

void get_input(char buffer[], int size);
void make_fcb(char buffer[]);
void encode(char buffer[],int len);

char splash[]="Keys version 3.0 configuration utility. Zephyr '95\n";

void main(void)
{
char fbuf[1024];
char buffer[25]="    32 bit Protected Mode";
FILE *file;
int flen,i;


if( (file=fopen("keys.com","rb")) == NULL)	// Try to open file
  {
  printf("Needs to have keys.com in the current directory.\n");
  exit(0);
  }

flen=fread(fbuf,1,1024,file);	// File has to be shorter than 1024 bytes
fclose(file);			// Read data and close file

encode(buffer,sizeof(buffer));	// Decode the buffer
encode(&fbuf[FULLPATH],25);	
clrscr();
printf("%s",splash);
printf("Current path is: %s\n",&fbuf[FULLPATH]);
get_input(buffer,sizeof(buffer)-1);
if(strlen(buffer)==0)
  {
  printf("Configuration not changed.\n");
  exit(0);
  }
memcpy(&fbuf[FULLPATH],buffer,25);
printf("\n\nNew path: %s\n",buffer);
for(i=strlen(buffer);i>0;i--) if(buffer[i]=='\\') break;
strupr(&buffer[i+1]);
if(i>0) memcpy(&fbuf[SHORTPATH],&buffer[i+1],13);
fbuf[SHORTLEN]=strlen(&buffer[i+1]);
fbuf[SHORTLEN+1]=0;
make_fcb(&buffer[i+1]);
memcpy(&fbuf[FCBPATH],&buffer[i+1],11);
encode(&fbuf[FULLPATH],51);

file=fopen("keys.com","wb");
fwrite(fbuf,1,flen,file);
fclose(file);
}

void get_input(char buffer[], int size)
{
int i,key,len=0;

printf("Please input the full path and file name that you want to save data to.\n\n");
for(i=0;i<size;i++) printf("-");
printf("+");
for(i=-1;i<size;i++) printf("\b");

do{
  key=getch();
  switch(key)
    {
    case BS:	if(len>0)
		  {
		  printf("\b-\b");
		  len--;
		  }
		break;
    case CR:	break;
    default:	if(len<size)
		  {
		  buffer[len]=key;
		  printf("%c",key);
		  len++;
		  }
		break;
    }
  } while(key!=0xd);
buffer[len]=0;
}

void make_fcb(char buffer[])
{
int i,j;

for(i=strlen(buffer);i>0;i--) if(buffer[i]=='.') break;
if(i>0)
  {
  j=strlen(&buffer[i+1]);
  while(j<3)
    {
    buffer[i+j+1]=' ';
    j++;
    }
  memcpy(&buffer[8],&buffer[i+1],3);
  buffer[11]=0;
  for(;i<8;i++) buffer[i]=' ';
  return;
  }
for(i=strlen(buffer);i<11;i++) buffer[i]=' ';  
buffer[11]=0;
}

void encode(char buffer[], int len)
{
int i;

for(i=0;i<len;i++)
  buffer[i]^=0xff;
}